<!DOCTYPE html>
<html>
<head>
<meta charset="UTF-8">
<title>documentation/info_segments/add_char_offset_.info</title>
<meta name="Generator" content="Vim/9.1">
<meta name="plugin-version" content="vim9.0_v2">
<meta name="syntax" content="none">
<meta name="settings" content="number_lines,use_css,no_foldcolumn,expand_tabs,line_ids,pre_wrap,prevent_copy=,use_input_for_pc=none">
<meta name="colorscheme" content="PaperColor">
<style>
<!--
pre { white-space: pre-wrap; font-family: monospace; color: #d0d0d0; background-color: #000000; }
body { font-family: monospace; color: #d0d0d0; background-color: #000000; }
* { font-size: 1em; }
.textRainbow_lv1_p0 { color: #ffffe0; }
.textRainbow_lv0_o0 { color: #add8e6; }
.textRainbow_lv0_p0 { color: #add8e6; }
.LineNr { color: #585858; }
-->
</style>

<script>
<!--

/* function to open any folds containing a jumped-to line before jumping to it */
function JumpToLine()
{
  var lineNum;
  lineNum = window.location.hash;
  lineNum = lineNum.substr(1); /* strip off '#' */

  if (lineNum.indexOf('L') == -1) {
    lineNum = 'L'+lineNum;
  }
  var lineElem = document.getElementById(lineNum);
  /* Always jump to new location even if the line was hidden inside a fold, or
   * we corrected the raw number to a line ID.
   */
  if (lineElem) {
    lineElem.scrollIntoView(true);
  }
  return true;
}
if ('onhashchange' in window) {
  window.onhashchange = JumpToLine;
}

-->
</script>
</head>
<body onload='JumpToLine();'>
<pre id='vimCodeElement'>
<span id="L1" class="LineNr"> 1 </span>06/25/81  add_char_offset_
<span id="L2" class="LineNr"> 2 </span>
<span id="L3" class="LineNr"> 3 </span>
<span id="L4" class="LineNr"> 4 </span>Entry points in add_char_offset_:
<span id="L5" class="LineNr"> 5 </span>   <span class="textRainbow_lv0_p0">(</span>List is generated by the help command<span class="textRainbow_lv0_p0">)</span>
<span id="L6" class="LineNr"> 6 </span>
<span id="L7" class="LineNr"> 7 </span>
<span id="L8" class="LineNr"> 8 </span>:Entry: add_char_offset_: 05/11/81  add_char_offset_
<span id="L9" class="LineNr"> 9 </span>
<span id="L10" class="LineNr">10 </span>Function: returns a pointer to a character relative to the character
<span id="L11" class="LineNr">11 </span>referenced by the input pointer.  The displacement to the desired
<span id="L12" class="LineNr">12 </span>character may be positive, negative, or zero.
<span id="L13" class="LineNr">13 </span>
<span id="L14" class="LineNr">14 </span>
<span id="L15" class="LineNr">15 </span>Syntax:
<span id="L16" class="LineNr">16 </span>dcl add_char_offset_ entry <span class="textRainbow_lv0_p0">(</span>ptr<span class="textRainbow_lv0_o0">,</span> fixed bin <span class="textRainbow_lv1_p0">(</span>21<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span> returns <span class="textRainbow_lv0_p0">(</span>ptr<span class="textRainbow_lv0_p0">)</span>
<span id="L17" class="LineNr">17 </span>     reducible;
<span id="L18" class="LineNr">18 </span>new_pointer_value = add_char_offset_ <span class="textRainbow_lv0_p0">(</span>pointer_value<span class="textRainbow_lv0_o0">,</span>
<span id="L19" class="LineNr">19 </span>     char_displacement<span class="textRainbow_lv0_p0">)</span>;
<span id="L20" class="LineNr">20 </span>
<span id="L21" class="LineNr">21 </span>
<span id="L22" class="LineNr">22 </span>Arguments:
<span id="L23" class="LineNr">23 </span>pointer_value
<span id="L24" class="LineNr">24 </span>   is the original pointer to which the character displacement is
<span id="L25" class="LineNr">25 </span>   applied.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L26" class="LineNr">26 </span>char_displacement
<span id="L27" class="LineNr">27 </span>   is the displacement in characters to be applied to the above
<span id="L28" class="LineNr">28 </span>   pointer.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L29" class="LineNr">29 </span>new_pointer_value
<span id="L30" class="LineNr">30 </span>   is the result of this operation.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L31" class="LineNr">31 </span>
<span id="L32" class="LineNr">32 </span>
<span id="L33" class="LineNr">33 </span>Notes:  If the pointer supplied to add_char_offset_ does not point to a
<span id="L34" class="LineNr">34 </span>character boundary, this operation is applied to a pointer value which
<span id="L35" class="LineNr">35 </span>references the character containing the bit located by the input
<span id="L36" class="LineNr">36 </span>pointer.
<span id="L37" class="LineNr">37 </span>
<span id="L38" class="LineNr">38 </span>Thus, the program fragment
<span id="L39" class="LineNr">39 </span>     a_ptr = add_char_offset_ <span class="textRainbow_lv0_p0">(</span>a_ptr<span class="textRainbow_lv0_o0">,</span> 0<span class="textRainbow_lv0_p0">)</span>;
<span id="L40" class="LineNr">40 </span>may be used to insure that &quot;a_ptr&quot; points to a character boundary.
<span id="L41" class="LineNr">41 </span>
<span id="L42" class="LineNr">42 </span>If the result of applying the displacement would cause the pointer to
<span id="L43" class="LineNr">43 </span>reference outside the legal boundaries of a segment <span class="textRainbow_lv0_p0">(</span>either a negative
<span id="L44" class="LineNr">44 </span>offset or an offset beyond 256K words<span class="textRainbow_lv0_p0">)</span>, the result of the call
<span id="L45" class="LineNr">45 </span>is not defined.
<span id="L46" class="LineNr">46 </span>
<span id="L47" class="LineNr">47 </span>
<span id="L48" class="LineNr">48 </span>Examples:
<span id="L49" class="LineNr">49 </span>The program fragment
<span id="L50" class="LineNr">50 </span>
<span id="L51" class="LineNr">51 </span>     current_char_ptr = add_char_offset <span class="textRainbow_lv0_p0">(</span>current_char_ptr<span class="textRainbow_lv0_o0">,</span> -1<span class="textRainbow_lv0_p0">)</span>;
<span id="L52" class="LineNr">52 </span>
<span id="L53" class="LineNr">53 </span>changes the value of current_char_ptr to locate the previous character
<span id="L54" class="LineNr">54 </span>in the segment.
</pre>
<script defer src='https://static.cloudflareinsights.com/beacon.min.js' data-cf-beacon='{"token": "4b6a131644014aa29fd88953508c3a3d"}'></script></body>
</html>
<!-- vim: set foldmethod=manual : -->
